# Simple Substitution Cipher
# http://inventwithpython.com/hacking (BSD Licensed)
# Adapted by Alessandro Bugatti to make the test

import pyperclip, sys, random


LETTERS = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

def main():
    myMessage = ''
    nomefileIn = input("Inserisci il nome del file da cifrare/decifrare:")
    f = open(nomefileIn,"r",encoding='utf-8')
    for line in f:
        myMessage += line
    myKey = input("Inserisci la chiave:")
    m = input("Inserisci se vuoi cifrare (E) o decifrare (D)")
    if m == 'E':
        myMode = 'encrypt'
    else:
        myMode = 'decrypt'

    checkValidKey(myKey)

    if myMode == 'encrypt':
        translated = encryptMessage(myKey, myMessage)
    elif myMode == 'decrypt':
        translated = decryptMessage(myKey, myMessage)
    print('Using key %s' % (myKey))
    print('The %sed message is:' % (myMode))
    nomefileOut = input("Inserisci il nome del file in cui salvare il testo")
    out = open(nomefileOut,"w", encoding = 'utf-8')
    out.write(translated)
    print(translated)
    pyperclip.copy(translated)
    print()
    print('This message has been copied to the clipboard.')


def checkValidKey(key):
    keyList = list(key.upper())
    lettersList = list(LETTERS)
    keyList.sort()
    lettersList.sort()
    if keyList != lettersList:
        sys.exit('There is an error in the key or symbol set.')


def encryptMessage(key, message):
    return translateMessage(key, message, 'encrypt')


def decryptMessage(key, message):
    return translateMessage(key, message, 'decrypt')


def translateMessage(key, message, mode):
    translated = ''
    charsA = LETTERS
    charsB = key.upper()
    if mode == 'decrypt':
        # For decrypting, we can use the same code as encrypting. We
        # just need to swap where the key and LETTERS strings are used.
        charsA, charsB = charsB, charsA

    # loop through each symbol in the message
    for symbol in message:
        if symbol.upper() in charsA:
            # encrypt/decrypt the symbol
            symIndex = charsA.find(symbol.upper())
            translated += charsB[symIndex].upper()
    return translated


def getRandomKey():
    key = list(LETTERS)
    random.shuffle(key)
    return ''.join(key)


if __name__ == '__main__':
    main()
